##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=0 1 2 3 5 6 7 9 11 13 14 15 18 22 24 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }

# PALETTE
$(eval $(call IMG2SP, SET_PALETTE_FW, $(PALETTE)))
$(eval $(call IMG2SP, SET_FOLDER, src/assets/palette))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette))
# SPRITES
$(eval $(call IMG2SP, SET_FOLDER, src/assets/sprites))
$(eval $(call IMG2SP, CONVERT, img/sprites/player/astronaut_left.png , 8, 16, sp_player_left))
$(eval $(call IMG2SP, CONVERT, img/sprites/player/astronaut_right.png , 8, 16, sp_player_right))
$(eval $(call IMG2SP, CONVERT, img/sprites/player/astronaut_up.png , 8, 16, sp_player_up))
$(eval $(call IMG2SP, CONVERT, img/sprites/player/astronaut_down.png , 8, 16, sp_player_down))
$(eval $(call IMG2SP, CONVERT, img/sprites/bullet/bullet6x6.png , 6, 6, sp_bullet))
$(eval $(call IMG2SP, CONVERT, img/sprites/enemies/ranged/ranged_enemy10x14.png , 10, 14, sp_ranged_enemy))
$(eval $(call IMG2SP, CONVERT, img/sprites/enemies/melee/melee_enemy8x16.png , 8, 16, sp_melee_enemy))
# HUD
$(eval $(call IMG2SP, SET_FOLDER, src/assets/sprites/hud))
$(eval $(call IMG2SP, CONVERT, img/hud/hud_init_0.png, 72, 22, sp_hud_init_0))
$(eval $(call IMG2SP, CONVERT, img/hud/hud_init_1.png, 72, 22, sp_hud_init_1))
$(eval $(call IMG2SP, CONVERT, img/hud/energy_0.png, 8, 5, sp_energy_0))
$(eval $(call IMG2SP, CONVERT, img/hud/energy_1.png, 8, 5, sp_energy_1))
$(eval $(call IMG2SP, CONVERT, img/hud/o2_0.png, 16, 14, sp_o2_0))
$(eval $(call IMG2SP, CONVERT, img/hud/o2_1.png, 16, 14, sp_o2_1))
$(eval $(call IMG2SP, CONVERT, img/hud/o2_2.png, 16, 14, sp_o2_2))
$(eval $(call IMG2SP, CONVERT, img/hud/o2_3.png, 16, 14, sp_o2_3))
$(eval $(call IMG2SP, CONVERT, img/hud/o2_4.png, 16, 14, sp_o2_4))
$(eval $(call IMG2SP, CONVERT, img/hud/pieces_0.png, 18, 19, sp_pieces_0))
$(eval $(call IMG2SP, CONVERT, img/hud/pieces_1.png, 18, 19, sp_pieces_1))
$(eval $(call IMG2SP, CONVERT, img/hud/pieces_2.png, 18, 19, sp_pieces_2))
$(eval $(call IMG2SP, CONVERT, img/hud/pieces_3.png, 18, 19, sp_pieces_3))
$(eval $(call IMG2SP, CONVERT, img/hud/pieces_4.png, 18, 19, sp_pieces_4))
$(eval $(call IMG2SP, CONVERT, img/hud/pieces_5.png, 18, 19, sp_pieces_5))
###
$(eval $(call IMG2SP, SET_OUTPUT, bin))
###
# TILESETS
$(eval $(call IMG2SP, SET_FOLDER, src/assets/maps/level_1))
$(eval $(call IMG2SP, SET_IMG_FORMAT, zgtiles))
$(eval $(call IMG2SP, CONVERT, img/tilesets/tileset_1.png , 8, 8, g_tileset_1))
$(eval $(call IMG2SP, SET_FOLDER, src/assets/maps/level_2))
$(eval $(call IMG2SP, CONVERT, img/tilesets/tileset_2.png , 8, 8, g_tileset_2))
$(eval $(call IMG2SP, SET_FOLDER, src/assets/maps/level_3))
$(eval $(call IMG2SP, CONVERT, img/tilesets/tileset_3.png , 8, 8, g_tileset_3))
# SCREENS
$(eval $(call IMG2SP, SET_FOLDER, src/assets/screens/))
$(eval $(call IMG2SP, SET_IMG_FORMAT, screen))
$(eval $(call IMG2SP, CONVERT, img/screens/s_menu.png , 0, 0, s_menu))
$(eval $(call IMG2SP, CONVERT, img/screens/s_credits.png , 0, 0, s_credits))
$(eval $(call IMG2SP, CONVERT, img/screens/s_controls.png , 0, 0, s_controls))