;; ___  ___                 ______                _    
;; |  \/  |                 | ___ \              | |   
;; | .  . | ___   ___  _ __ | |_/ /_ __ ___  __ _| | __
;; | |\/| |/ _ \ / _ \| '_ \| ___ \ '__/ _ \/ _` | |/ /
;; | |  | | (_) | (_) | | | | |_/ / | |  __/ (_| |   < 
;; \_|  |_/\___/ \___/|_| |_\____/|_|  \___|\__,_|_|\_\
;;                                                                                                       
;; Copyright (C) 2020  
;; This file is part of the Amstrad game: MoonBreak
;;
;; Authors:
;; Ricardo Antonio, Ruiz Falcó (@R1ckyman) (ricky.rfr@gmail.com)
;; Alejandro Vicente, Rodríguez Segado (@VicenteSegado) (alejandrors13091993@gmail.com)
;; Enrique Antonio, Cores Rodríguez (@QuiqueCores) (encorod@gmail.com)
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>
.include "cpctelera.h.s"
.include "man/game_manager.h.s"
.include "man/entity_manager.h.s"

.area _DATA
.area _CODE

.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm

_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm

   ;; Init Game Manager
   call game_manager_init

_main_loop:
   call game_manager_get_state
   or a
   jr z, _game_loop
   dec a
   jr z, _main_menu
   dec a
   jr z, _map_loading
   dec a
   jr z, _game_over
   dec a
   jr z, _pause_menu
_victory:
   call game_manager_victory
   jr _main_loop
_game_loop:
   call game_manager_update
   call cpct_waitVSYNC_asm
   call game_manager_render
   call game_manager_update_entities
   jr _main_loop
_main_menu:
   call game_manager_main_menu
   jr _main_loop
_map_loading:
   call game_manager_load_map
   jr _main_loop
_game_over:
   call game_manager_game_over
   jr _main_loop
_pause_menu:
   call game_manager_pause_menu
   jr _main_loop