;; ___  ___                 ______                _    
;; |  \/  |                 | ___ \              | |   
;; | .  . | ___   ___  _ __ | |_/ /_ __ ___  __ _| | __
;; | |\/| |/ _ \ / _ \| '_ \| ___ \ '__/ _ \/ _` | |/ /
;; | |  | | (_) | (_) | | | | |_/ / | |  __/ (_| |   < 
;; \_|  |_/\___/ \___/|_| |_\____/|_|  \___|\__,_|_|\_\
;;                                                                                                       
;; Copyright (C) 2020  
;; This file is part of the Amstrad game: MoonBreak
;;
;; Authors:
;; Ricardo Antonio, Ruiz Falcó (@R1ckyman) (ricky.rfr@gmail.com)
;; Alejandro Vicente, Rodríguez Segado (@VicenteSegado) (alejandrors13091993@gmail.com)
;; Enrique Antonio, Cores Rodríguez (@QuiqueCores) (encorod@gmail.com)
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>
;;
;;  O2 MANAGER
;;
.module O2_Manager
.include "o2_manager.h.s"
.include "cpctelera.h.s"
.include "hud_manager.h.s"
.include "man/game_manager.h.s"

o2_timer:
    .db #0xFF
o2_state:
    .db #4

o2_manager_init::
    ld a, #0xFFFF          ;; /
    ld (#o2_timer), a      ;; \ INITIALIZING O2_TIMER
    ld a, #4         ;; /
    ld (#o2_state), a      ;; \ INITIALIZING O2_STATE
    
    ret

o2_manager_restore_o2::
    call o2_manager_init
    call hud_manager_restore_o2
    ret

o2_manager_update::
    ld a, (#o2_timer)
    dec a
    jr nz, #o2_timer_nz
o2_timer_z:
    call hud_manager_dec_o2
    ld a, (#o2_state)
    dec a
    jr nz, #o2_state_nz
o2_state_z:
    call game_manager_game_over
o2_state_nz:
    ld (#o2_state), a
    ld a, #0xFF
o2_timer_nz:
    ld (#o2_timer), a

    ret