;; ___  ___                 ______                _    
;; |  \/  |                 | ___ \              | |   
;; | .  . | ___   ___  _ __ | |_/ /_ __ ___  __ _| | __
;; | |\/| |/ _ \ / _ \| '_ \| ___ \ '__/ _ \/ _` | |/ /
;; | |  | | (_) | (_) | | | | |_/ / | |  __/ (_| |   < 
;; \_|  |_/\___/ \___/|_| |_\____/|_|  \___|\__,_|_|\_\
;;                                                                                                       
;; Copyright (C) 2020  
;; This file is part of the Amstrad game: MoonBreak
;;
;; Authors:
;; Ricardo Antonio, Ruiz Falcó (@R1ckyman) (ricky.rfr@gmail.com)
;; Alejandro Vicente, Rodríguez Segado (@VicenteSegado) (alejandrors13091993@gmail.com)
;; Enrique Antonio, Cores Rodríguez (@QuiqueCores) (encorod@gmail.com)
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;  WEAPON MANAGER
;;		Manager weapons using a basic memory management system.
;;		Allows to create, delete and update weapons.
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
.module Weapon_Manager

;;==============================================================================================================================
;;==============================================================================================================================
;;  FUNCTIONS
;;  
;;      INIT:                   Sets the vector of weapons to zero.
;;      CREATE:                 Create a weapon for an entity.
;;      DESTROY:                Destroy the weapons of a dead entity.   (NOT IMPLEMENTED)
;;      GETWEAPONARRAYHL:       Return the array of weapons.
;;      SETPLAYERWEAPONS:       Assigns a rifle and shotgun to the player.
;;      ASSIGNENEMYRIFLE:       Create an enemy rifle for an entity.
;;      ASSIGNENEMYSHOTGUN:     Create an enemy shotgun for an entity.
;;==============================================================================================================================
;;==============================================================================================================================
.globl weapon_manager_init
.globl weapon_manager_create
.globl weapon_manager_destroy
.globl weapon_manager_setPlayerWeapons
.globl weapon_manager_getWeaponArrayHL
.globl weapon_manager_assignEnemyRifle
.globl weapon_manager_assignEnemyShotgun
