;; ___  ___                 ______                _    
;; |  \/  |                 | ___ \              | |   
;; | .  . | ___   ___  _ __ | |_/ /_ __ ___  __ _| | __
;; | |\/| |/ _ \ / _ \| '_ \| ___ \ '__/ _ \/ _` | |/ /
;; | |  | | (_) | (_) | | | | |_/ / | |  __/ (_| |   < 
;; \_|  |_/\___/ \___/|_| |_\____/|_|  \___|\__,_|_|\_\
;;                                                                                                       
;; Copyright (C) 2020  
;; This file is part of the Amstrad game: MoonBreak
;;
;; Authors:
;; Ricardo Antonio, Ruiz Falcó (@R1ckyman) (ricky.rfr@gmail.com)
;; Alejandro Vicente, Rodríguez Segado (@VicenteSegado) (alejandrors13091993@gmail.com)
;; Enrique Antonio, Cores Rodríguez (@QuiqueCores) (encorod@gmail.com)
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;  BEHAVIOR_ATTACK
;;      Determines the actions of an entity when in enters attack mode.
;;      These actions will depend on the entity class and the state it is in.
;;      
;;      -BEHAVIOR_ATTACK:            The entity in this state will attack.
;;          -ATTACK_TYPE:            Checks the class of the entity to perform one type off attack or another.
;;              -ATTACK_OR_SCAPE:    If the entity has 1 life, it will flee away from player to heal it.
;;              -MELEE_ATTACK:       The entity changes its state to mobe_to to reach the player.
;;              -SHORT_RANGE_ATTACK: Entity attacks at close range.
;;              -GENERATE:           The entity generates enemies.
;;              -TELEPORT:           Teleports the entity to a random point on the map.
;;      -BHEAVIOR_ESCAPE:            The main task of the entity changes to be healed.
;;      -BEHAVIOR_HEAL:              The entity heals until reaching its maximum life. 
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
.module Ai_Behavior_Attack

.globl ai_control_system_behavior_attack
.globl ai_control_system_behavior_escape
.globl ai_control_system_behavior_heal
.globl ai_control_system_short_range_attack