;; ___  ___                 ______                _    
;; |  \/  |                 | ___ \              | |   
;; | .  . | ___   ___  _ __ | |_/ /_ __ ___  __ _| | __
;; | |\/| |/ _ \ / _ \| '_ \| ___ \ '__/ _ \/ _` | |/ /
;; | |  | | (_) | (_) | | | | |_/ / | |  __/ (_| |   < 
;; \_|  |_/\___/ \___/|_| |_\____/|_|  \___|\__,_|_|\_\
;;                                                                                                       
;; Copyright (C) 2020  
;; This file is part of the Amstrad game: MoonBreak
;;
;; Authors:
;; Ricardo Antonio, Ruiz Falcó (@R1ckyman) (ricky.rfr@gmail.com)
;; Alejandro Vicente, Rodríguez Segado (@VicenteSegado) (alejandrors13091993@gmail.com)
;; Enrique Antonio, Cores Rodríguez (@QuiqueCores) (encorod@gmail.com)
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;  SELECTORS_AND_PARENT_NODES
;;      This class houses the selectors and paren nodes of the AI behaviors.
;;      Each parent node will be composed of a set of behaviors that may vary according to the circumstances of the game.
;;      Whenever a leaf node is reached, the behavior of the entity will return to the parent node, starting the behavior tree
;;      again.
;;      
;;      -PATROL_SELECTOR:       Assign each entity with AI the patrol task.
;;          -BEHAVIOR_PATROL:   Assign the patrol coordinates to each entity with patrol mode.
;;      -GUARD_SELECTOR:        Assign an entity guardian mode.
;;          -BHEAVIOR_GUARD:    The entity remains guarding a perimeter without moving. 
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
.module Ai_Selectors

.globl ai_control_system_behavior_patrol_selector
.globl ai_control_system_behavior_patrol
.globl ai_control_system_behavior_guard_selector
.globl ai_control_system_behavior_guard