;; ___  ___                 ______                _    
;; |  \/  |                 | ___ \              | |   
;; | .  . | ___   ___  _ __ | |_/ /_ __ ___  __ _| | __
;; | |\/| |/ _ \ / _ \| '_ \| ___ \ '__/ _ \/ _` | |/ /
;; | |  | | (_) | (_) | | | | |_/ / | |  __/ (_| |   < 
;; \_|  |_/\___/ \___/|_| |_\____/|_|  \___|\__,_|_|\_\
;;                                                                                                       
;; Copyright (C) 2020  
;; This file is part of the Amstrad game: MoonBreak
;;
;; Authors:
;; Ricardo Antonio, Ruiz Falcó (@R1ckyman) (ricky.rfr@gmail.com)
;; Alejandro Vicente, Rodríguez Segado (@VicenteSegado) (alejandrors13091993@gmail.com)
;; Enrique Antonio, Cores Rodríguez (@QuiqueCores) (encorod@gmail.com)
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;  UTILITIES
;;      Utility functions that support AI behaviors.
;;      
;;      -INTERFERED:             Change AI tasks according to interference.
;;      -ZONE_SCANNER:           Perform a scan of an area control delimited by the sight value of the entity.
;;      -PLAYER_PROXIMITY:       Detects if the player is within range of the entity.
;;      -ADJUST_SHOOTING_SPEEDS: Adjusts the speed of the enemy weapon based on the player's position.
;;      -BEHAVIOR_PROCESSING:    Puts the entity in processing.
;;      -ESCAPE_PATH_SEARCH:     Find the corner furthest from the player so that the entity escape to there.
;;      -RANDOM_Y_POSITION:      Calculates a random Y-coordinate within the boundaries of the map.
;;      -RANDOM_X_POSITION:      Calculates a random x-coordinate within the boundaries of the map.
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
;;==============================================================================================================================
.module Ai_Control_System

.globl ai_control_system_interfered
.globl ai_control_system_zone_scanner
.globl ai_control_system_player_proximity
.globl ai_control_system_adjust_shooting_speeds
.globl ai_control_system_behavior_processing
.globl ai_control_system_escape_path_search
.globl ai_control_system_random_x_position
.globl ai_control_system_random_y_position